package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryDurationCurrencyDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryDurationCurrencyDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryDurationCurrencyDao;
import com.friday.custody.entity.DataDictionaryDurationCurrencyEntity;
import com.friday.custody.service.basicService.DataDictionaryDurationCurrencyService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryDurationCurrencyService")
public class DataDictionaryDurationCurrencyServiceImpl extends ServiceImpl<DataDictionaryDurationCurrencyDao, DataDictionaryDurationCurrencyEntity>
        implements DataDictionaryDurationCurrencyService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryDurationCurrencyEntity> page = this.page(
                new Query<DataDictionaryDurationCurrencyEntity>().getPage(params),
                new QueryWrapper<DataDictionaryDurationCurrencyEntity>()
        );

        return new PageUtils(page);
    }

    @Autowired
    private DataDictionaryDurationCurrencyDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryDurationCurrencyEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryDurationCurrencyDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryDurationCurrencyDetailsEntity::getOriginValue, DataDictionaryDurationCurrencyDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryDurationCurrencyEntity::getId, DataDictionaryDurationCurrencyEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryDurationCurrencyDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryDurationCurrencyEntity 查询失败！");
        }
        return result;
    }
    @Override
    public R queryData(String type) {
        List<DataDictionaryDurationCurrencyEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryDurationCurrencyEntity::getKeyStr
                            ,DataDictionaryDurationCurrencyEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}